import femto.mode.HiRes16Color;
import femto.Game;
import femto.State;
import femto.Sprite;
import femto.input.Button;
import ZxSpectrum;
import femto.font.TIC80;
import femto.sound.Mixer;
import femto.sound.Procedural;
//import femto.math;
import femto.palette.Pico8;

import ZombieEntity;
import HorizBarEntity;
import VertBarEntity;
import TimeMeterEntity;
import Common;
import Event;
import maps.map;

public class MainDay extends State {
    
    // Images
    Bubble bubbleImage;
    Winner winnerImage;
    //TreeEntity treeArray[];
    map tilemap;

    // Sounds
    arrigd_zombie_roar_3 sfx1;
    breviceps_zombie_gargles sfx2;
    crocytc_zombie3 sfx3;
    missozzy_zombie_02 sfx4;
    missozzy_zombie_04 sfx5;
    thanra_zombie_roar sfx6;
    
    //HiRes16Color screen; // the screenmode we want to draw with
    Event[] events;
    TimeMeterEntity timeMeterEntity;
    int currSfxNum;
    float angle; // floats are actually FixedPoint (23.8)
    int counter; // variables are automatically initialized to 0 or null
    boolean isGameOver;
    boolean isWon;
    long programStartTimeMs; // the start time of the program
    HeroEntity heroEntity;
   
    // Avoid allocation in a State's constructor.
    // Allocate on init instead.
    void init(){
        //System.gc();
        System.out.println("init(): free=" + java.lang.Runtime.getRuntime().freeMemory());

        // minus 1 so that the Common.currentFrameStartTimeMs do not start from 0.
        programStartTimeMs = System.currentTimeMillis() - 1; 
        Common.currentFrameStartTimeMs = System.currentTimeMillis() - programStartTimeMs;
        
        //
        bubbleImage =  new Bubble();
        timeMeterEntity =  new TimeMeterEntity();
        winnerImage = new Winner();
        heroEntity = new HeroEntity();
        heroEntity.run();
        // treeArray = new TreeEntity[10];
        // for(int i=0; i < 10; i++)
        // {
        //     treeArray[i] = new TreeEntity();
        //     treeArray[i].x = Math.random( 5, 220-5 - treeArray[i].width() );
        //     treeArray[i].y = Math.random( 5, 176-5 - treeArray[i].height() );
        // }
        
        tilemap = new map();
        
        
        // sfx1 = new arrigd_zombie_roar_3(0);
        // sfx2 = new breviceps_zombie_gargles(0);
        // sfx3 = new crocytc_zombie3(0);
        // sfx4 = new missozzy_zombie_02(0);
        // sfx5 = new missozzy_zombie_04(0);
        // sfx6 = new thanra_zombie_roar(0);
        // currSfxNum = 1;

        // Initialize the Mixer at 8khz
        //Mixer.init(8000);
        
        events = new Event[Common.MAX_EVENTS]; //
        for(int i=0; i < Common.MAX_EVENTS; i++)
        {
            events[i] = new Event();
        }
        
        // Set events for random sounds.
        //events[4].setSfxEvent((long)3*1000, sfx2, 15000, 40000 );
        
        System.out.println("2. init(): free=" + java.lang.Runtime.getRuntime().freeMemory());
    }
    
    // Might help in certain situations
    void shutdown(){
        //screen = null;
    }
    
    // update is called by femto.Game every frame
    void update(){
        
        // long currTime = System.currentTimeMillis();
        
        // Read the current time. Substract the program start time to make the value smaller, so it fits to 32 bits. 
        Common.currentFrameStartTimeMs = System.currentTimeMillis() - programStartTimeMs;
        //System.out.println("update().currentFrameStartTimeMs=" + Common.currentFrameStartTimeMs);
        
        // Change to a new state when A is pressed
        if( Button.A.justPressed() )
            Game.changeState( new MainDay() );
            

        if(!isGameOver)
        {
            //
            heroEntity.update();

        }
        
        // *** Draw
        
        // Fill the screen using Pattern.png
        Main.screen.clear(7);
        
        //
        tilemap.drawDayField(Main.screen);

        // // Draw trees
        // for(int i=0; i < 10; i++)
        //     treeArray[i].drawMe( Main.screen );
            
        // Draw hero        
        heroEntity.draw( Main.screen );
            
        // Print time meter
        float normalizedTimeLeft = ((float)Common.LEVEL_TIMEOUT - Common.currentFrameStartTimeMs) / (float)Common.LEVEL_TIMEOUT;
        if(normalizedTimeLeft <= 0) 
        {
            if(!isGameOver)
            {
                isWon = true;
                isGameOver = true;
            }
            normalizedTimeLeft = 0;
        }
        timeMeterEntity.drawMeter( Main.screen, normalizedTimeLeft );
            
        // Draw the winner dialog
        if(isWon)
            Main.DrawWinnerDialog(winnerImage);
        
        // print fps
        Main.screen.setTextPosition( 0, 0 );
        Main.screen.textColor = 3;
        Main.screen.print((int)(Main.screen.fps()+0.5));
        
        // Update the screen with everything that was drawn
        Main.screen.flush();
    }
    
}


